#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <R.h>
#include <Rdefines.h>

SEXP rbmp(SEXP filename, SEXP breitex, SEXP offsetx, SEXP hoehey, SEXP offsety) {
	
	char *p_myfilename;
	PROTECT(filename = AS_CHARACTER(filename));
	p_myfilename = R_alloc(strlen(CHAR(STRING_ELT(filename, 0))), 80);
	strncpy(p_myfilename, CHAR(STRING_ELT(filename, 0)), 80);
	int mybreite = INTEGER_VALUE(breitex);
	int myoffsetx = INTEGER_VALUE(offsetx);
	int myhoehe = INTEGER_VALUE(hoehey);
	int myoffsety = INTEGER_VALUE(offsety);
	FILE *myfile;
	SEXP matrix, list_names, list, tmpbreite;
	int *p_matrix, *p_tmpbreite;
	int byte, breite, hoehe, summe, offset, farbtiefe;
	int zeilenanfang = 0;
	
	if ((myfile=fopen(p_myfilename, "rb")) == 0) {
		warning("IO error\n");
		//Matrix fuer Rueckgabe erstellen
		PROTECT(list = allocVector(VECSXP, 2));
		PROTECT(tmpbreite = NEW_INTEGER(1));
		p_tmpbreite = INTEGER_POINTER(tmpbreite);
		p_tmpbreite[0] = 1;
		PROTECT(matrix = NEW_INTEGER(1));
		p_matrix = INTEGER_POINTER(matrix);
		p_matrix[0] = 0;
		SET_VECTOR_ELT(list, 0, matrix);
		SET_VECTOR_ELT(list, 1, tmpbreite);
		UNPROTECT(1);
		PROTECT(list_names = allocVector(STRSXP, 2));
		SET_STRING_ELT(list_names, 0,  mkChar("matrix"));
		SET_STRING_ELT(list_names, 1,  mkChar("width"));
		setAttrib(list, R_NamesSymbol, list_names);
		UNPROTECT(4);
		return list;
	}
	
	// ueberpruefen ob bmp
	rewind(myfile);
	byte = fgetc(myfile);
	byte = byte + fgetc(myfile);
	
	if(byte != 143)  {
		warning("No BMP file\n");
		//Matrix fuer Rueckgabe erstellen
		PROTECT(list = allocVector(VECSXP, 2));
		PROTECT(tmpbreite = NEW_INTEGER(1));
		p_tmpbreite = INTEGER_POINTER(tmpbreite);
		p_tmpbreite[0] = 1;
		PROTECT(matrix = NEW_INTEGER(1));
		p_matrix = INTEGER_POINTER(matrix);
		p_matrix[0] = 0;
		SET_VECTOR_ELT(list, 0, matrix);
		SET_VECTOR_ELT(list, 1, tmpbreite);
		UNPROTECT(1);
		PROTECT(list_names = allocVector(STRSXP, 2));
		SET_STRING_ELT(list_names, 0,  mkChar("matrix"));
		SET_STRING_ELT(list_names, 1,  mkChar("width"));
		setAttrib(list, R_NamesSymbol, list_names);
		UNPROTECT(4);
		return list;
	}
	
	
	// Farbtiefe des bildes ermitteln
	rewind(myfile);
	fseek(myfile, 28L, SEEK_SET);
	farbtiefe = 0;
	for(int i = 0; i < 2; ++i)   {
		byte = fgetc(myfile);
		farbtiefe = farbtiefe + (byte <<= 8*i);
	}
	if(farbtiefe != 24)  {
		warning("Only images with 24-bits colour depth are supported!\n");
		//Matrix fuer Rueckgabe erstellen
		PROTECT(list = allocVector(VECSXP, 2));
		PROTECT(tmpbreite = NEW_INTEGER(1));
		p_tmpbreite = INTEGER_POINTER(tmpbreite);
		p_tmpbreite[0] = 1;
		PROTECT(matrix = NEW_INTEGER(1));
		p_matrix = INTEGER_POINTER(matrix);
		p_matrix[0] = 0;
		SET_VECTOR_ELT(list, 0, matrix);
		SET_VECTOR_ELT(list, 1, tmpbreite);
		UNPROTECT(1);
		PROTECT(list_names = allocVector(STRSXP, 2));
		SET_STRING_ELT(list_names, 0,  mkChar("matrix"));
		SET_STRING_ELT(list_names, 1,  mkChar("width"));
		setAttrib(list, R_NamesSymbol, list_names);
		UNPROTECT(4);
		return list;
	}
	
	// Bild einlesen und verarbeiten
	// offset ermitteln
	offset = 0;
	rewind(myfile);
	fseek(myfile, 10L, SEEK_SET);
	
	for(int i = 0; i < 4; ++i)   {
		byte = fgetc(myfile);
		offset = offset + (byte <<= 8*i);
	}
	
	// breite des bildes ermitteln
	rewind(myfile);
	fseek(myfile, 18L, SEEK_SET);
	breite = 0;
	for(int i = 0; i < 4; ++i)   {
		byte = fgetc(myfile);
		breite = breite + (byte <<= 8*i);
	}
	
	// hoehe des bildes ermitteln
	rewind(myfile);
	fseek(myfile, 22L, SEEK_SET);
	hoehe = 0;
	for(int i = 0; i < 4; ++i)   {
		byte = fgetc(myfile);
		hoehe = hoehe + (byte <<= 8*i);
	}
	
	// Steht das Bild auf dem Kopf?
	if(hoehe < 0 || breite < 0)   {
		zeilenanfang = abs(hoehe)-1;
	}
	hoehe = abs(hoehe);
	breite = abs(breite);
	
	// Ausschnitt ueberpruefen
	if(mybreite > breite | mybreite < 0)  {
		mybreite = breite;
		warning("will use width = %i\n", mybreite);
	}
	if(mybreite == 0)  {
		mybreite = breite;
	}
	if(myhoehe > hoehe | myhoehe < 0)   {
		myhoehe = hoehe;
		warning("will use height = %i\n", myhoehe);
	}
	if(myhoehe == 0)   {
		myhoehe = hoehe;
	}
	if(myoffsetx + mybreite > breite)   {
		myoffsetx = breite - mybreite;
		warning("will use offset.x = %i\n", myoffsetx);
	}
	if(myoffsety + myhoehe > hoehe)   {
		myoffsety = hoehe - myhoehe;
		warning("will use offset.y = %i\n", myoffsety);
	}
	
	//Speicherplatz fuer matrix allozieren
	PROTECT(matrix = NEW_INTEGER(mybreite*myhoehe));
	p_matrix = INTEGER_POINTER(matrix);
	
	rewind(myfile);
	fseek(myfile, (long)offset, SEEK_SET);
	
	//Padding ermitteln
	//Anzahl Byte pro Zeile muss durch 4 teilbar sein
	int padding = (4-(breite*3)%4)%4;
	
	// daten einlesen
	rewind(myfile);
	fseek(myfile, (long)offset, SEEK_SET);
	for(int k = 0; k < hoehe; ++k)    {
		for(int l = 0; l < breite; ++l)    {
			summe = 0;
			for(int j = 0; j < 3; ++j)   {
				byte = fgetc(myfile);
				summe = summe + byte;
			}
			int zeile = k;
			if(zeilenanfang > 0)   {
				zeile = zeilenanfang - k;
			}
			
			if(l>=myoffsetx && l < mybreite + myoffsetx && zeile>= myoffsety && zeile< myhoehe + myoffsety) {
				p_matrix[zeile - myoffsety + (l-myoffsetx)*myhoehe] = summe/3;
			}
		} // for breite
		
		// padding
		for(int loop = 0; loop < padding; ++loop)   {
		  byte = fgetc(myfile);
		}
	} // for hoehe
	
	fclose(myfile);
	UNPROTECT(2);
	PROTECT(list = allocVector(VECSXP, 2));
	PROTECT(tmpbreite = NEW_INTEGER(1));
	p_tmpbreite = INTEGER_POINTER(tmpbreite);
	p_tmpbreite[0] = mybreite;
	SET_VECTOR_ELT(list, 0, matrix);
	SET_VECTOR_ELT(list, 1, tmpbreite);
	UNPROTECT(1);
	PROTECT(list_names = allocVector(STRSXP, 2));
	SET_STRING_ELT(list_names, 0,  mkChar("matrix"));
	SET_STRING_ELT(list_names, 1,  mkChar("width"));
	setAttrib(list, R_NamesSymbol, list_names);
	UNPROTECT(2);
	return list;
}
